/* Copyright	Massachusetts Institute of Technology	1987, 1988
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of M.I.T. not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  M.I.T. makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * M.I.T. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL M.I.T.
 * BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */
/*
   Copyright 1994, Frederick W. Umminger.
   All rights reserved.
   */


#ifndef _JuggleP_h
#define _JuggleP_h

#include "Juggle.h"
#include <DLList.h>
#include <SLList.h>
extern "C"
{
#include<X11/xpm.h>
};
/* include superclass private header file */
#include <X11/CoreP.h>

/* 
  juggle.h

  (c) Frederick Umminger 1993
  All rights reserved

  */


/*
  Classes
  */


 class Ball {

  private:

  public:
   float x;
   float y;
   float ox;
   float oy;
   float vx;
   float vy;
   int ref_count;
   int color;
   
   void step();

   Ball();

 };


typedef struct {
  float x;
  float y;
} hand;

/* define unique representation types not found in <X11/StringDefs.h> */

#define XtRJuggleResource "JuggleResource"

typedef struct {
    int empty;
} JuggleClassPart;

typedef struct _JuggleClassRec {
    CoreClassPart	core_class;
    JuggleClassPart	juggle_class;
} JuggleClassRec;

extern JuggleClassRec juggleClassRec;

typedef struct {
    /* resources */
    Pixel foreground;
    int number_hands;
    float frames_per_second;
     float throw_velocity; /* pixels per second */
    float* tv_ptr;
    float gravitational_force; /* pixels per second per second */
    float* gf_ptr;
    char* pattern_filename;
    char* pixmap_filename;
    int width;
    int height;
    /* private state */
    int time_per_frame;
    int frames_per_throw; 
      DLList<void*>* color_list_ptr;
    DLList<Ball*>* ball_list_ptr;
    int counter; /* for the animation */
    DLList<hand>* hand_list_ptr ;
    Pix current_hand;
    SLList<Ball*>* state_machine; 
    SLList<int>* juggle_pattern;
    Pixmap ball_pixmap;
    Pixmap ball_shapemask;
    Pixmap buffer;
    GC draw_gc;
    GC copy_gc;
    unsigned int ball_bitmap_width;
    unsigned int ball_bitmap_height;
    int ball_x_hotspot;
    int ball_y_hotspot;
  
} JugglePart;

typedef struct _JuggleRec {
    CorePart	core;
    JugglePart	juggle;
} JuggleRec;

#endif /* _JuggleP_h */
